;	DAC Code Interrupt Routine.
;	==========================
;	There are several versions of the interrupt here, according to the table lookup method.
;	The "Original" two, which didn't work using "MOVIW" with pre. or post inc./dec.,
;	and one using Program Memory which did.
	
	
;	Original ISR code. Uses the Post-Inc./Dec. "moviw FSR0--/++".
;	-----------------  ========================================
;	Uses the delinquent "moviw" instruction.
;	This didn't work. The DAC's froze at the initial condition only.
;	
;	Interrupt flags are sorted first. For the PWM 5 Period flag(s), the code run depends on the
;	flag "flags,wf_tbl_dir_f", directing whether a new sample for DAC 1 is taken in the
;	direction going UP or DOWN the sample table. Should the table pointer FSR0<H:L> be
;	indexed off either end of the table, the pointer is repositioned and the direction flag reversed.
;	The table ends are defined by the labels "wf_tbl_top" and "wf_tbl_end".
;	For the SPI 1 peripheral, no code is currently required.

;isr_start							; Interrupt sorting.
;	movlb	bank_0						; ( Bank 0.)
;	btfsc	PIR6,PWM5IF					; Is there a PWM5 Interrupt flag,
;	bra	isr_pwm5_start					; If NO - skip, else jump.
;
;	movlb   bank_27						; ( Bank 27.)
;	btfsc   PWM5INTF,PRIF					; Is there a PWM5 Period Interrupt ?
;	bra	isr_pwm5_start					; If NO - skip, else jump.
;
;	movlb   bank_0						; ( Bank 0.)
;	btfsc   PIR1,SSP1IF					; Is there an SPI1 Interrupt ?
;	bra	isr_spi1_start					; If NO - skip, else jump.
;
;	retfie							; Return from Interrupt.
;    
;isr_pwm5_start							; Pointer Incrementing or Decrementing ?
;	movlb   bank_27						; ( Bank 27.)
;	bcf	PWM5INTF,PRIF					; Clear the PWM5 Period Interrupt flag,
;	movlb   bank_0						; ( Bank 0.)
;	bcf	PIR6,PWM5IF					; and the PWM5 group PIR6 flag. (Probably redundant.)
;	btfsc   flags,wf_tbl_dir_f				; Is the pointer direction Decrement ? ( Flag = 0.)
;	bra	isr_wf_tbl_inc					; If YES - skip, else jump for Increment.
;
;isr_wf_tbl_dec							; Decrement the table pointer UP the sample table.
;	moviw   FSR0--						; Fetch the current sample and decrement the pointer. Samples go from -90 deg. to +90 deg. values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH					; Output the new sample values to DAC 1,
;	movwf   DAC2REFH					; and DAC 2.
;	movlw	b'00000011'
;	movwf	DACLD
;	movlw   LOW wf_tbl_top					; Check the pointer position.
;	subwf   FSR0L,W
;	btfsc   STATUS,C					; Is the pointer off the TOP of the table ?
;	retfie							; If NO - return, else skip to reset the pointer,
;
;	movlw   LOW wf_tbl_top + 1				; one sample DOWN from the TOP,
;	movwf   FSR0L
;	movlb   bank_0						; ( Bank 0.)
;	bsf	flags,wf_tbl_dir_f				; and reverse the direction flag. ( 1 = DOWN.)
;	retfie							; Return from Interrupt.
;    
;isr_wf_tbl_inc							; Increment the table pointer DOWN the sample table.
;	moviw   FSR0++						; Fetch the current sample and increment the pointer. Samples go from +90 deg. to -90 deg. values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH					; Output the new sample values to DAC 1,
;	movwf   DAC2REFH					; and DAC 2.
;	movlw	b'00000011'
;	movwf	DACLD
;	movf	FSR0L,W						; Check the pointer position.
;	sublw   LOW wf_tbl_end
;	btfsc   STATUS,C					; Is the pointer off the END of the table ?
;	retfie							; If NO - return, else skip to reset the pointer,
;
;	movlw   LOW wf_tbl_end - 1				; one sample UP from the END,
;	movwf   FSR0L
;	movlb   bank_0						; ( Bank 0.)
;	bcf	flags,wf_tbl_dir_f				; and reverse the direction flag. ( 0 = UP.)
;	retfie							; Return from Interrupt. 
;    
;isr_spi1_start
;	bcf	PIR1,SSP1IF					; Clear the SPI1 Interrupt flag.
;    
;	retfie							; Return from Interrupt.
 

;	Original ISR code. Uses the Pre-Inc./Dec. "moviw --/++FSR0".
;	-----------------  ========================================
;	This didn't work either. The DAC's output the initial and the first sample change - then froze.
;
;	Interrupt flags are sorted first. For the PWM 5 Period flag(s), the code run depends on the
;	flag "flags,wf_tbl_dir_f", directing whether a new sample for DAC 1 is taken in the
;	direction going UP or DOWN the sample table. Should the table pointer FSR0<H:L> be
;	indexed to either end of the table, the pointer is repositioned and the direction flag reversed.
;	The table ends are defined by the labels "wf_tbl_top" and "wf_tbl_end".
;	For the SPI 1 peripheral, no code is currently required.
;
;isr_start							; Interrupt sorting.
;	movlb	bank_0						; ( Bank 0.)
;	btfsc	PIR6,PWM5IF					; Is there a PWM5 Interrupt flag,
;	bra	isr_pwm5_start					; If NO - skip, else jump.
;	movlb   bank_27						; ( Bank 27.)
;	btfsc   PWM5INTF,PRIF					; Is there a PWM5 Period Interrupt ?
;	bra	isr_pwm5_start					; If NO - skip, else jump.
;
;	movlb   bank_0						; ( Bank 0.)
;	btfsc   PIR1,SSP1IF					; Is there an SPI1 Interrupt ?
;	bra	isr_spi1_start					; If NO - skip, else jump.
;
;	retfie							; Return from Interrupt.
;    
;isr_pwm5_start							; Pointer Incrementing or Decrementing ?
;	movlb   bank_27						; ( Bank 27.)
;	bcf	PWM5INTF,PRIF					; Clear the PWM5 Period Interrupt flag,
;	movlb   bank_0						; ( Bank 0.)
;	bcf	PIR6,PWM5IF					; and the PWM5 group PIR6 flag.
;	btfsc   flags,wf_tbl_dir_f				; Is the pointer direction Decrement ? ( Flag = 0.)
;	bra	isr_wf_tbl_inc					; If YES - skip, else jump for Increment.
;
;isr_wf_tbl_dec							; Decrement the table pointer UP the sample table.
;	moviw   --FSR0						; Decrement the pointer and fetch the current sample. Samples go from -90 deg. to +90 deg. values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH					; Output the new sample values to DAC 1,
;	movwf   DAC2REFH					; and DAC 2.
;	movlw	b'00000011'
;	movwf	DACLD
;	movlw   LOW wf_tbl_top					; Check the pointer position.
;	subwf   FSR0L,W
;	btfss   STATUS,Z					; Is the pointer at the TOP of the table ?
;	retfie							; If YES - skip to reset the pointer, else return.
;
;	movlw   LOW wf_tbl_top + 1				; Set the pointer one sample DOWN from the TOP,
;	movwf   FSR0L
;	movlb   bank_0						; ( Bank 0.)
;	bsf		flags,wf_tbl_dir_f			; and reverse the direction flag. ( 1 = DOWN.)
;	retfie							; Return from Interrupt.
;    
;isr_wf_tbl_inc							; Increment the table pointer DOWN the sample table.
;	moviw   ++FSR0						; Increment the pointer and fetch the current sample. Samples go from +90 deg. to -90 deg. values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH					; Output the new sample values to DAC 1,
;	movwf   DAC2REFH					; and DAC 2.
;	movlw	b'00000011'
;	movwf	DACLD
;	movlw   LOW wf_tbl_end					; Check the pointer position.
;	subwf   FSR0L,W
;	btfss   STATUS,Z					; Is the pointer at the END of the table ?
;	retfie							; If YES - skip to reset the pointer, else return.
;	movlw   LOW wf_tbl_end - 1				; Set the pointer one sample UP from the END,
;	movwf   FSR0L
;	movlb   bank_0						; ( Bank 0.)
;	bcf	flags,wf_tbl_dir_f				; and reverse the direction flag. ( 0 = UP.)
;	retfie							; Return from Interrupt. 
;    
;isr_spi1_start
;	bcf	PIR1,SSP1IF						; Clear the SPI1 Interrupt flag.
;    	retfie							; Return from Interrupt.
	
	
;   DAC Code ISR.			; DEBUG. For the Program Memory sample table method.
;   ============
;	ISR code that works.
;	-------------------
;	This code reads the sample table stored in the Program Memory, using the call "sample_data" and the "brw" instruction.
;	This is slightly less efficient than the original "moviw" instruction, but at least it works.
;	It updates both Dac's 1 and 2 for comparison.
;	Clearing the individual "PWM5INTF,PRIF" interrupt flag also clears the Group "PIR6,PWM5IF" flag apparently,
;	so no need to clear that too.
;	If an SPI interrupt occurs, this just sets a flag for the Main Loop to act.
;
;isr_start							; Interrupt sorting.
;	movlb   bank_27						; ( Bank 27.)
;	btfsc   PWM5INTF,PRIF				; Is there a PWM 5 Period Interrupt ?
;	bra	    isr_pwm5_start					; If NO - skip, else jump.
;	movlb   bank_0						; ( Bank 0.)
;	btfsc   PIR1,SSP1IF					; Is there an SPI 1 Interrupt ?
;	bra	    isr_spi1_start					; If NO - skip, else jump.
;	retfie								; Return from Interrupt.
;    
;isr_pwm5_start						; Pointer Incrementing or Decrementing ?
;	bcf	    PWM5INTF,PRIF				; Clear the PWM 5 Period Interrupt flag,
;	movlb   bank_0						; ( Bank 0.)
;	btfsc   flags,wf_tbl_dir_f			; Is the pointer direction Decrement ? ( Flag = 0.)
;	bra	    isr_wf_tbl_inc					; If YES - skip, else jump for Increment.
;isr_wf_tbl_dec						; Decrement the table pointer UP, and output the next sample.
;	movf	table_pointer,W				; Fetch the current sample.
;	decf	table_pointer,F				; Decrement the pointer UP the table for the next sample,
;	call	sample_data					; and fetch the current one. Samples go from -ve to +ve values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH
;	movwf   DAC2REFH
;	movlw	b'00000011'					; Output the new sample values to DAC 1 and DAC 2.
;	movwf	DACLD
;	movlb   bank_0						; ( Bank 0.)
;	btfss	table_pointer,bit_7			; Has the table pointer rolled over ? ( table_pointer<7> = 1 ?)
;	retfie									; If Yes - skip to reset the pointer, else return.
;	movlw   d'01'						; Set the pointer one sample DOWN from the TOP,
;	movwf   table_pointer
;	bsf	    flags,wf_tbl_dir_f			; and reverse the direction flag. ( 1 = DOWN.)
;	retfie								; Return from Interrupt.
;    
;isr_wf_tbl_inc						; Increment the table pointer DOWN, and output the next sample.
;	movf	table_pointer,W				; Fetch the current sample.
;	incf	table_pointer,F				; Increment the pointer DOWN the table for the next sample,
;	call	sample_data					; and fetch the current one. Samples go from +ve to -ve values.
;	movlb   bank_11						; ( Bank 11.)
;	movwf   DAC1REFH
;	movwf   DAC2REFH
;	movlw	b'00000011'					; Output the new sample values to DAC 1 and DAC 2.
;	movwf	DACLD
;	movlb   bank_0						; ( Bank 0.)
;	movf	table_pointer,W				; Check the pointer position.
;	sublw	d'10'
;	btfsc   STATUS,C					; Is the pointer off the END of the table ? ( C = 0.)
;	retfie									; If NO - return, else skip to reset the pointer,
;	movlw   d'09'						; Set the pointer one sample UP from the END,
;	movwf   table_pointer
;	bcf	    flags,wf_tbl_dir_f			; and reverse the direction flag. ( 0 = UP.)
;	retfie								; Return from Interrupt. 
;    
;isr_spi1_start
;	bcf		PIR1,SSP1IF					; Clear the SPI 1 Interrupt flag,
;	
;	retfie								; Return from Interrupt.
 
	

